(

// algo001t v0.04 091031
// Really basic - SinOsc and one tone
// Uses case and collections of arpeggiated triads
// Uses SCNumberBox
// Prohibits values lower than 0.01;
// 091031: even simpler, uses a task.




var w;
var mainBut, mainButState = true;
var myTime = 0.1, timeBox, randTime;


var stream;




w = Window("SC Algorithm GUI Tutor 000a", Rect(20, 800, 240, 100));



// Synth to play it: in this case it's a basic sine wave.  You can experiment with others...
s = Server.local;


SynthDef( "Algorithmic", { arg freq;
	var out;

	out = SinOsc.ar( freq, 0, mul: EnvGen.kr( Env.perc(0.001, 0.2, 1.0, -4), levelScale: 0.1, doneAction: 2 ));

	Out.ar( 0, out );
}).send(s);



// here's the stream...

stream = Task({
	loop({
		Synth( "Algorithmic", [ \freq, 60.midicps ] );
// or you can choose this:
// 		Synth( "Algorithmic", [ \freq, [ 60, 62, 63, 66, 68 ].choose.midicps ] );
		myTime.wait;
 	});
});

// look at the other examples, but also:
// choose, if, while, for, forBy, do, switch, case
// see control structures, and think up some uses for them



// The static text for the word 'speed'


a = StaticText(w, Rect(130, 20, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "speed";



timeBox = NumberBox(w, Rect(130, 40, 60, 20));
		timeBox.clipLo = 0.01;
		timeBox.value = 0.1;
		timeBox.scroll_step = 0.01;
		timeBox.action = ({ arg v;
			myTime = v.value;
		});

// The static text for the word 'seconds'


a = StaticText(w, Rect(200, 40, 40, 20));
a.font_(Font("Helvetica", 12));
a.string = "secs";




mainBut = Button(w, Rect(20,40,100,20))


		.states_([["Play"],["Stop"]])
		.action_({ arg butt;
			mainButState = mainBut.value;



			if ( mainButState == 1 , // this is if the button is on!
							{ stream.reset; stream.play }, // do this
							{ stream.stop } // otherwise do this.
			);



		}); // end of action
w.front;
)
